/*
 * Copyright (c) 2010-2011, The MiCode Open Source Community (www.micode.net)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *        http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
// Description：用于支持小米便签最底层的数据库相关操作，和sqlnote的关系上是子集关系，即data是note的子集（节点）。
// SqlData其实就是也就是所谓数据中的数据
// 数据库中的数据类，用于执行最底层的数据库相关操作，包括初始化、获取、提交、加载、共享数据，获取当前ID

package net.micode.notes.gtask.data;

import android.content.ContentResolver;
import android.content.ContentUris;
import android.content.ContentValues;
import android.content.Context;
import android.database.Cursor;
import android.net.Uri;
import android.util.Log;

import net.micode.notes.data.Notes;
import net.micode.notes.data.Notes.DataColumns;
import net.micode.notes.data.Notes.DataConstants;
import net.micode.notes.data.Notes.NoteColumns;
import net.micode.notes.data.NotesDatabaseHelper.TABLE;
import net.micode.notes.gtask.exception.ActionFailureException;

import org.json.JSONException;
import org.json.JSONObject;


public class SqlData {
    // 功能描述：得到类的简写名称存入字符串TAG中
    // 实现过程：调用getSimpleName ()函数
    private static final String TAG = SqlData.class.getSimpleName();
    // TAG常量，用于在日志中标记这个类

    private static final int INVALID_ID = -99999; // 无效ID常量

    // 来自Notes类中定义的DataColumn中的一些常量

    // 集合了interface DataColumns中所有SF常量
    // PROJECTION_DATA常量数组，用于查询数据表中的字段
    public static final String[] PROJECTION_DATA = new String[] {
            DataColumns.ID, DataColumns.MIME_TYPE, DataColumns.CONTENT, DataColumns.DATA1,
            DataColumns.DATA3
    };

    // 以下五个变量作为sql表中5列的编号
    // 数据表字段的索引常量，用于读取查询结果集
    public static final int DATA_ID_COLUMN = 0;

    public static final int DATA_MIME_TYPE_COLUMN = 1;

    public static final int DATA_CONTENT_COLUMN = 2;

    public static final int DATA_CONTENT_DATA_1_COLUMN = 3;

    public static final int DATA_CONTENT_DATA_3_COLUMN = 4;

    private ContentResolver mContentResolver;
    // ContentResolver对象，用于操作数据表
    // 判断是否直接用Content生成，是为true，否则为false
    private boolean mIsCreate; // 是否创建了数据

    private long mDataId; // 数据ID

    private String mDataMimeType; // 数据类型

    private String mDataContent; // 数据内容

    private long mDataContentData1; // 数据字段1

    private String mDataContentData3; // 数据字段3

    private ContentValues mDiffDataValues; // ContentValues对象，用于更新数据表的内容

    // 功能描述：构造函数，用于初始化数据，初始化ContentResolver对象
    // 参数注解：mContentResolver用于获取ContentProvider提供的数据
    // 参数注解：mIsCreate表征当前数据是用哪种方式创建（两种构造函数的参数不同）
    public SqlData(Context context) {
        mContentResolver = context.getContentResolver();
        mIsCreate = true;
        mDataId = INVALID_ID; // mDataId置初始值-99999
        mDataMimeType = DataConstants.NOTE;
        mDataContent = "";
        mDataContentData1 = 0;
        mDataContentData3 = "";
        mDiffDataValues = new ContentValues();
    }

    // 功能描述：构造函数，初始化数据
    // 参数注解：mContentResolver用于获取ContentProvider提供的数据
    // 参数注解：mIsCreate表征当前数据是用哪种方式创建（两种构造函数的参数不同）
    public SqlData(Context context, Cursor c) {
        mContentResolver = context.getContentResolver();
        mIsCreate = false;
        loadFromCursor(c);
        mDiffDataValues = new ContentValues();
    }

    // 功能描述：从光标处加载数据，从Cursor对象中读取数据
    // 从当前的光标处将五列的数据加载到该类的对象
    private void loadFromCursor(Cursor c) {
        mDataId = c.getLong(DATA_ID_COLUMN); // 读取数据ID
        mDataMimeType = c.getString(DATA_MIME_TYPE_COLUMN); // 读取数据类型
        mDataContent = c.getString(DATA_CONTENT_COLUMN); // 读取数据内容
        mDataContentData1 = c.getLong(DATA_CONTENT_DATA_1_COLUMN); // 读取数据字段1
        mDataContentData3 = c.getString(DATA_CONTENT_DATA_3_COLUMN); // 读取数据字段3
    }

    // 功能描述：设置用于共享的数据，并提供异常抛出与处理机制，设置数据内容
    // 参数注解：
    public void setContent(JSONObject js) throws JSONException {
        // 如果传入的JSONObject对象中有DataColumns.ID这一项，则设置，否则设为INVALID_ID
        // 从JSONObject对象中读取数据，若不存在则使用默认值
        long dataId = js.has(DataColumns.ID) ? js.getLong(DataColumns.ID) : INVALID_ID;
        // 比较新数据和旧数据，如果不同则添加到ContentValues对象中
        if (mIsCreate || mDataId != dataId) {
            mDiffDataValues.put(DataColumns.ID, dataId);
        }
        mDataId = dataId;

        String dataMimeType = js.has(DataColumns.MIME_TYPE) ? js.getString(DataColumns.MIME_TYPE)
                : DataConstants.NOTE;
        if (mIsCreate || !mDataMimeType.equals(dataMimeType)) {
            mDiffDataValues.put(DataColumns.MIME_TYPE, dataMimeType);
        }
        mDataMimeType = dataMimeType;

        String dataContent = js.has(DataColumns.CONTENT) ? js.getString(DataColumns.CONTENT) : "";
        if (mIsCreate || !mDataContent.equals(dataContent)) {
            mDiffDataValues.put(DataColumns.CONTENT, dataContent);
        }
        mDataContent = dataContent;

        long dataContentData1 = js.has(DataColumns.DATA1) ? js.getLong(DataColumns.DATA1) : 0;
        if (mIsCreate || mDataContentData1 != dataContentData1) {
            mDiffDataValues.put(DataColumns.DATA1, dataContentData1);
        }
        mDataContentData1 = dataContentData1;

        String dataContentData3 = js.has(DataColumns.DATA3) ? js.getString(DataColumns.DATA3) : "";
        if (mIsCreate || !mDataContentData3.equals(dataContentData3)) {
            mDiffDataValues.put(DataColumns.DATA3, dataContentData3);
        }
        mDataContentData3 = dataContentData3;
    }

    // 功能描述：获取共享的数据内容，并提供异常抛出与处理机制
    // 参数注解：
    public JSONObject getContent() throws JSONException {
        // 如果数据还没有在数据库中创建，则返回null，并打印错误日志
        if (mIsCreate) {
            Log.e(TAG, "it seems that we haven't created this in database yet");
            return null;
        }
        // 创建JSONObject对象。并将相关数据放入其中，并返回。
        JSONObject js = new JSONObject();
        js.put(DataColumns.ID, mDataId);
        js.put(DataColumns.MIME_TYPE, mDataMimeType);
        js.put(DataColumns.CONTENT, mDataContent);
        js.put(DataColumns.DATA1, mDataContentData1);
        js.put(DataColumns.DATA3, mDataContentData3);
        return js;
    }

    // 功能描述：commit函数用于把当前造作所做的修改保存到数据库
    // 参数注解：
    public void commit(long noteId, boolean validateVersion, long version) {
        // 如果数据还没有在数据库中创建，则将其插入到数据库中
        if (mIsCreate) {
            // 如果数据id无效且存在于差异数据值中，则从差异数据值中删除该id
            if (mDataId == INVALID_ID && mDiffDataValues.containsKey(DataColumns.ID)) {
                mDiffDataValues.remove(DataColumns.ID);
            }
            // 将数据与所属笔记的id关联起来，并将其插入到数据库中
            mDiffDataValues.put(DataColumns.NOTE_ID, noteId);
            Uri uri = mContentResolver.insert(Notes.CONTENT_DATA_URI, mDiffDataValues);
            try {
                // 从uri中获取新插入数据的id
                mDataId = Long.valueOf(uri.getPathSegments().get(1));
            } catch (NumberFormatException e) {
                Log.e(TAG, "Get note id error :" + e.toString());
                throw new ActionFailureException("create note failed");
            }
        } else {
            // 如果数据已存在于数据库中，则将其更新
            if (mDiffDataValues.size() > 0) {
                int result = 0;
                // 如果需要验证版本号，则只有当笔记的版本号与指定版本号相同时，才能更新数据
                if (!validateVersion) {
                    result = mContentResolver.update(ContentUris.withAppendedId(
                            Notes.CONTENT_DATA_URI, mDataId), mDiffDataValues, null, null);
                } else {
                    result = mContentResolver.update(ContentUris.withAppendedId(
                                    Notes.CONTENT_DATA_URI, mDataId), mDiffDataValues,
                            " ? in (SELECT " + NoteColumns.ID + " FROM " + TABLE.NOTE
                                    + " WHERE " + NoteColumns.VERSION + "=?)", new String[] {
                                    String.valueOf(noteId), String.valueOf(version)
                            });
                }
                // 如果更新的数据数量为0，则打印警告日志
                if (result == 0) {
                    Log.w(TAG, "there is no update. maybe user updates note when syncing");
                }
            }
        }
        // 清空差异数据值，并将是否创建标志设为false
        mDiffDataValues.clear();
        mIsCreate = false;
    }

    // 功能描述：获取当前id
    // 实现过程：返回数据索引
    // 参数注解：
    public long getId() {
        return mDataId;
    }
}